﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ImprovingCode
{
    public static class IntExtensions
    {
        public static TimeSpan Minutes(this int m)
        {
            return new TimeSpan(0, 0, m, 0);
        }
        public static TimeSpan Days(this int d)
        {
            return new TimeSpan(d, 0, 0, 0);
        }
    }

    public class SpamSender
    {
        public SpamSender(string message, TimeSpan senderEvery, TimeSpan endAfter)
        {
        }
    }

    public class Uzytkownik
    {
        public string Login { get; set; }
        public string Pesel { get; set; }
        public DateTime DataUrodzenia { get; set; }

        public static bool isValidClassic(Uzytkownik u)
        {
            if (string.IsNullOrEmpty(u.Login) && u.Login.Length < 3)
                return false;
            if (string.IsNullOrEmpty(u.Pesel) && u.Pesel.Length != 11)
                return false;
            if ((DateTime.Now - u.DataUrodzenia).TotalDays < 18 * 365)
                return false;

            return true;
        }

        public static bool isValid(Uzytkownik uzytkownik)
        {
            Func<Uzytkownik, bool>[] rules = 
            {
                u => string.IsNullOrEmpty(u.Login) && u.Login.Length < 3,
                u => string.IsNullOrEmpty(u.Pesel) && u.Pesel.Length != 11,
                u => (DateTime.Now - u.DataUrodzenia).TotalDays < 18 * 365
            };

            return rules.All(rule => rule(uzytkownik));
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            // poprawianie czytelności kodu
            var spammer1 = new SpamSender("Kup pan cegłę", new TimeSpan(0, 0, 2, 0), new TimeSpan(3, 0, 0, 0));

            var spammer2 = new SpamSender(
                message: "Kup pan cegłę",
                senderEvery: 1.Minutes(),
                endAfter: 3.Days());

            // bardziej funkcjonalne podejście
            Uzytkownik u = null;
            Uzytkownik.isValid(u);

        }
    }
}
